root: true
extends:
  - 'plugin:@gitlab/default'
  - 'plugin:storybook/csf'
rules:
  import/no-extraneous-dependencies: off
  no-restricted-imports:
  - error
  # We only should be consuming bootstrap-vue components from `src/`
  - patterns:
      - "bootstrap-vue/*"
      - "!bootstrap-vue/src"
      - "!bootstrap-vue/package.json"
  vue/no-v-html: error
  '@gitlab/vue-prefer-dollar-scopedslots': error
# test-specific configuration
overrides:
- files:
  - "**/*.spec.js"
  - "tests/jest_setup.js"
  - "tests/__helpers__/*.js"
  extends:
    - 'plugin:@gitlab/jest'
  settings:
    import/resolver:
      jest:
        jestConfigFile: "./jest.config.js"
  rules:
    promise/always-return: off
    jest/expect-expect:
      - warn
      - assertFunctionNames:
          - "expect*"
    no-restricted-syntax:
    - error
    - selector: CallExpression[callee.name='afterEach'] CallExpression MemberExpression[object.name='wrapper'][property.name='destroy']
      message: No need to call wrapper.destroy() in afterEach due to enableAutoDestroy being enabled suite-wide.
    no-restricted-imports:
    - error
    - paths:
      - name: "@vue/test-utils"
        importNames:
        - createLocalVue
        message: createLocalVue should be avoided. Perform operations on global Vue instance instead
- files:
    - '**/*.stories.js'
  rules:
    no-restricted-globals:
      - error
      - name: 'setTimeout'
        message: 'use setStoryTimeout from the utils/test_utils instead.'
- files:
  - "config.js"
  - "rollup.config.js"
  - "**/*.documentation.js"
  - "**/index.js"
  - "**/*.stories.js"
  # Files below should be migrated to named exports
  - "src/components/mixins/toolbox_mixin.js"
  - "src/utils/breakpoints.js"
  - "src/utils/charts/config.js"
  - "src/utils/charts/theme.js"
  - "src/utils/use_mock_intersection_observer.js"
  rules:
    import/no-default-export: off
